<html>
<head>
<title>Ogre::WaveformControllerFunction Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1WaveformControllerFunction.html">WaveformControllerFunction</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::WaveformControllerFunction Class Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::WaveformControllerFunction" --><!-- doxytag: inherits="ControllerFunction&lt; Real &gt;" -->
<p>Predefined controller function based on a waveform.  
 <a href="classOgre_1_1WaveformControllerFunction.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::WaveformControllerFunction:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1WaveformControllerFunction__inherit__graph.gif" border="0" usemap="#Ogre_1_1WaveformControllerFunction_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1WaveformControllerFunction_inherit__map" id="Ogre_1_1WaveformControllerFunction_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1ControllerFunction.html" title="Ogre::ControllerFunction\&lt; Real \&gt;" alt="" coords="11,83,224,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="64,5,171,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1WaveformControllerFunction-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#a1b83f439aae8d785f1db065ac7e59139">WaveformControllerFunction</a> (<a class="el" href="group__General.html#gabf2e0412a783a6f708ca1a58abb45c1b">WaveformType</a> wType, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> base=0, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> frequency=1, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> phase=0, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> amplitude=1, bool deltaInput=true, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> dutyCycle=0.5)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor, requires at least a wave type, other parameters can be defaulted unless required.  <a href="#a1b83f439aae8d785f1db065ac7e59139"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#aec4afc09add54fd7872f78e299e1d276">calculate</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> source)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Overridden function.  <a href="#aec4afc09add54fd7872f78e299e1d276"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#a950dedb7a1feb23702600ce1b8f54c31">getAdjustedInput</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> input)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Overridden from <a class="el" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction</a>.  <a href="#a950dedb7a1feb23702600ce1b8f54c31"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__General.html#gabf2e0412a783a6f708ca1a58abb45c1b">WaveformType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#a4d20ceeb97414c820c091c2d2d1cb1ba">mWaveType</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#aef4d97d6aa5570d4a4dcaeb11dd3fb34">mBase</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#a293bcc15c3553f687b890ad711aab0b7">mFrequency</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#a3de22fc6e6c69377856b2f97f47b299b">mPhase</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#aa47e62b3fc8bf48e93e6fd280085b57b">mAmplitude</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#a649691c7cb6c4c4b10547ca66d38df7e">mDutyCycle</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerFunction.html#a5141c8004f8393f985a6c06fafdb50c5">mDeltaInput</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If true, function will add input values together and wrap at 1.0 before evaluating.  <a href="#a5141c8004f8393f985a6c06fafdb50c5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Predefined controller function based on a waveform. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>A waveform function translates parametric input to parametric output based on a wave. The factors affecting the function are:<ul>
<li>wave type - the shape of the wave</li>
<li>base - the base value of the output from the wave</li>
<li>frequency - the speed of the wave in cycles per second</li>
<li>phase - the offset of the start of the wave, e.g. 0.5 to start half-way through the wave</li>
<li>amplitude - scales the output so that instead of lying within [0,1] it lies within [0,1] * amplitude</li>
<li>duty cycle - the active width of a PWM signal </li>
</ul>
</dd></dl>
<dl class="user"><dt><b></b></dt><dd>Note that for simplicity of integration with the rest of the controller insfrastructure, the output of the wave is parametric i.e. 0..1, rather than the typical wave output of [-1,1]. To compensate for this, the traditional output of the wave is scaled by the following function before output: </dd></dl>
<dl class="user"><dt><b></b></dt><dd>output = (waveoutput + 1) * 0.5 </dd></dl>
<dl class="user"><dt><b></b></dt><dd>Hence a wave output of -1 becomes 0, a wave ouput of 1 becomes 1, and a wave output of 0 becomes 0.5. </dd></dl>

<p>Definition at line <a class="el" href="OgrePredefinedControllers_8h_source.html#l00258">258</a> of file <a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a1b83f439aae8d785f1db065ac7e59139"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::WaveformControllerFunction" ref="a1b83f439aae8d785f1db065ac7e59139" args="(WaveformType wType, Real base=0, Real frequency=1, Real phase=0, Real amplitude=1, bool deltaInput=true, Real dutyCycle=0.5)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1WaveformControllerFunction.html#a1b83f439aae8d785f1db065ac7e59139">Ogre::WaveformControllerFunction::WaveformControllerFunction</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__General.html#gabf2e0412a783a6f708ca1a58abb45c1b">WaveformType</a>&#160;</td>
          <td class="paramname"><em>wType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>base</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>frequency</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>phase</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>amplitude</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>deltaInput</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>dutyCycle</em> = <code>0.5</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Default constructor, requires at least a wave type, other parameters can be defaulted unless required. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">deltaInput</td><td>If true, signifies that the input will be a delta value such that the function should add it to an internal counter before calculating the output. </td></tr>
    <tr><td class="paramname">dutyCycle</td><td>Used in PWM mode to specify the pulse width. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="aec4afc09add54fd7872f78e299e1d276"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::calculate" ref="aec4afc09add54fd7872f78e299e1d276" args="(Real source)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1WaveformControllerFunction.html#aec4afc09add54fd7872f78e299e1d276">Ogre::WaveformControllerFunction::calculate</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>source</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Overridden function. </p>

<p>Implements <a class="el" href="classOgre_1_1ControllerFunction.html#a0f77d037a78ce3b430c0a18fbe711df0">Ogre::ControllerFunction&lt; Real &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="a950dedb7a1feb23702600ce1b8f54c31"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::getAdjustedInput" ref="a950dedb7a1feb23702600ce1b8f54c31" args="(Real input)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1WaveformControllerFunction.html#a950dedb7a1feb23702600ce1b8f54c31">Ogre::WaveformControllerFunction::getAdjustedInput</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>input</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Overridden from <a class="el" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction</a>. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1ControllerFunction.html#a6c6a617c6db75b58e3e1a8a2e9dbed8e">Ogre::ControllerFunction&lt; Real &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="aa47e62b3fc8bf48e93e6fd280085b57b"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::mAmplitude" ref="aa47e62b3fc8bf48e93e6fd280085b57b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1WaveformControllerFunction.html#aa47e62b3fc8bf48e93e6fd280085b57b">Ogre::WaveformControllerFunction::mAmplitude</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePredefinedControllers_8h_source.html#l00265">265</a> of file <a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a>.</p>

</div>
</div>
<a class="anchor" id="aef4d97d6aa5570d4a4dcaeb11dd3fb34"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::mBase" ref="aef4d97d6aa5570d4a4dcaeb11dd3fb34" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1WaveformControllerFunction.html#aef4d97d6aa5570d4a4dcaeb11dd3fb34">Ogre::WaveformControllerFunction::mBase</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePredefinedControllers_8h_source.html#l00262">262</a> of file <a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a>.</p>

</div>
</div>
<a class="anchor" id="addf729e6eb31d54c20e9bb48b116252e"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::mDeltaCount" ref="addf729e6eb31d54c20e9bb48b116252e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>  <a class="el" href="classOgre_1_1ControllerFunction.html">Ogre::ControllerFunction</a>&lt; <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>  &gt;::<a class="el" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreController_8h_source.html#l00060">60</a> of file <a class="el" href="OgreController_8h_source.html">OgreController.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5141c8004f8393f985a6c06fafdb50c5"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::mDeltaInput" ref="a5141c8004f8393f985a6c06fafdb50c5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1ControllerFunction.html">Ogre::ControllerFunction</a>&lt; <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>  &gt;::<a class="el" href="classOgre_1_1ControllerFunction.html#a5141c8004f8393f985a6c06fafdb50c5">mDeltaInput</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>If true, function will add input values together and wrap at 1.0 before evaluating. </p>

<p>Definition at line <a class="el" href="OgreController_8h_source.html#l00059">59</a> of file <a class="el" href="OgreController_8h_source.html">OgreController.h</a>.</p>

</div>
</div>
<a class="anchor" id="a649691c7cb6c4c4b10547ca66d38df7e"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::mDutyCycle" ref="a649691c7cb6c4c4b10547ca66d38df7e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1WaveformControllerFunction.html#a649691c7cb6c4c4b10547ca66d38df7e">Ogre::WaveformControllerFunction::mDutyCycle</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePredefinedControllers_8h_source.html#l00266">266</a> of file <a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a293bcc15c3553f687b890ad711aab0b7"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::mFrequency" ref="a293bcc15c3553f687b890ad711aab0b7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1WaveformControllerFunction.html#a293bcc15c3553f687b890ad711aab0b7">Ogre::WaveformControllerFunction::mFrequency</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePredefinedControllers_8h_source.html#l00263">263</a> of file <a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3de22fc6e6c69377856b2f97f47b299b"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::mPhase" ref="a3de22fc6e6c69377856b2f97f47b299b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1WaveformControllerFunction.html#a3de22fc6e6c69377856b2f97f47b299b">Ogre::WaveformControllerFunction::mPhase</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePredefinedControllers_8h_source.html#l00264">264</a> of file <a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4d20ceeb97414c820c091c2d2d1cb1ba"></a><!-- doxytag: member="Ogre::WaveformControllerFunction::mWaveType" ref="a4d20ceeb97414c820c091c2d2d1cb1ba" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__General.html#gabf2e0412a783a6f708ca1a58abb45c1b">WaveformType</a> <a class="el" href="classOgre_1_1WaveformControllerFunction.html#a4d20ceeb97414c820c091c2d2d1cb1ba">Ogre::WaveformControllerFunction::mWaveType</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePredefinedControllers_8h_source.html#l00261">261</a> of file <a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgrePredefinedControllers_8h_source.html">OgrePredefinedControllers.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:02
</p>
</body>
</html>
